(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("vue"), require("@kq_npm/client_common_vue/_utils/gis-utils"), require("@kq_npm/client_common_vue/init.js"));
	else if(typeof define === 'function' && define.amd)
		define("@kq_npm/client_leaflet_vue", ["vue", "@kq_npm/client_common_vue/_utils/gis-utils", "@kq_npm/client_common_vue/init.js"], factory);
	else if(typeof exports === 'object')
		exports["@kq_npm/client_leaflet_vue"] = factory(require("vue"), require("@kq_npm/client_common_vue/_utils/gis-utils"), require("@kq_npm/client_common_vue/init.js"));
	else
		root["@kq_npm/client_leaflet_vue"] = factory(root["Vue"], root["@kq_npm/client_common_vue/_utils/gis-utils"], root["@kq_npm/client_common_vue/init.js"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE__1895__, __WEBPACK_EXTERNAL_MODULE__7135__, __WEBPACK_EXTERNAL_MODULE__7997__) {
return /******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 504:
/***/ (function(module, __webpack_exports__, __webpack_require__) {

/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(3645);
/* harmony import */ var _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0__);
// Imports

var ___CSS_LOADER_EXPORT___ = _node_modules_css_loader_dist_runtime_api_js__WEBPACK_IMPORTED_MODULE_0___default()(function(i){return i[1]});
// Module
___CSS_LOADER_EXPORT___.push([module.id, "\n.leaflet-control-minimap {\r\n  margin-right: 16px !important;\r\n  margin-bottom: 16px !important;\n}\r\n", ""]);
// Exports
/* harmony default export */ __webpack_exports__["Z"] = (___CSS_LOADER_EXPORT___);


/***/ }),

/***/ 3645:
/***/ (function(module) {



/*
  MIT License http://www.opensource.org/licenses/mit-license.php
  Author Tobias Koppers @sokra
*/
// css base code, injected by the css-loader
// eslint-disable-next-line func-names
module.exports = function (cssWithMappingToString) {
  var list = []; // return the list of modules as css string

  list.toString = function toString() {
    return this.map(function (item) {
      var content = cssWithMappingToString(item);

      if (item[2]) {
        return "@media ".concat(item[2], " {").concat(content, "}");
      }

      return content;
    }).join("");
  }; // import a list of modules into the list
  // eslint-disable-next-line func-names


  list.i = function (modules, mediaQuery, dedupe) {
    if (typeof modules === "string") {
      // eslint-disable-next-line no-param-reassign
      modules = [[null, modules, ""]];
    }

    var alreadyImportedModules = {};

    if (dedupe) {
      for (var i = 0; i < this.length; i++) {
        // eslint-disable-next-line prefer-destructuring
        var id = this[i][0];

        if (id != null) {
          alreadyImportedModules[id] = true;
        }
      }
    }

    for (var _i = 0; _i < modules.length; _i++) {
      var item = [].concat(modules[_i]);

      if (dedupe && alreadyImportedModules[item[0]]) {
        // eslint-disable-next-line no-continue
        continue;
      }

      if (mediaQuery) {
        if (!item[2]) {
          item[2] = mediaQuery;
        } else {
          item[2] = "".concat(mediaQuery, " and ").concat(item[2]);
        }
      }

      list.push(item);
    }
  };

  return list;
};

/***/ }),

/***/ 3379:
/***/ (function(module, __unused_webpack_exports, __webpack_require__) {



var isOldIE = function isOldIE() {
  var memo;
  return function memorize() {
    if (typeof memo === 'undefined') {
      // Test for IE <= 9 as proposed by Browserhacks
      // @see http://browserhacks.com/#hack-e71d8692f65334173fee715c222cb805
      // Tests for existence of standard globals is to allow style-loader
      // to operate correctly into non-standard environments
      // @see https://github.com/webpack-contrib/style-loader/issues/177
      memo = Boolean(window && document && document.all && !window.atob);
    }

    return memo;
  };
}();

var getTarget = function getTarget() {
  var memo = {};
  return function memorize(target) {
    if (typeof memo[target] === 'undefined') {
      var styleTarget = document.querySelector(target); // Special case to return head of iframe instead of iframe itself

      if (window.HTMLIFrameElement && styleTarget instanceof window.HTMLIFrameElement) {
        try {
          // This will throw an exception if access to iframe is blocked
          // due to cross-origin restrictions
          styleTarget = styleTarget.contentDocument.head;
        } catch (e) {
          // istanbul ignore next
          styleTarget = null;
        }
      }

      memo[target] = styleTarget;
    }

    return memo[target];
  };
}();

var stylesInDom = [];

function getIndexByIdentifier(identifier) {
  var result = -1;

  for (var i = 0; i < stylesInDom.length; i++) {
    if (stylesInDom[i].identifier === identifier) {
      result = i;
      break;
    }
  }

  return result;
}

function modulesToDom(list, options) {
  var idCountMap = {};
  var identifiers = [];

  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var id = options.base ? item[0] + options.base : item[0];
    var count = idCountMap[id] || 0;
    var identifier = "".concat(id, " ").concat(count);
    idCountMap[id] = count + 1;
    var index = getIndexByIdentifier(identifier);
    var obj = {
      css: item[1],
      media: item[2],
      sourceMap: item[3]
    };

    if (index !== -1) {
      stylesInDom[index].references++;
      stylesInDom[index].updater(obj);
    } else {
      stylesInDom.push({
        identifier: identifier,
        updater: addStyle(obj, options),
        references: 1
      });
    }

    identifiers.push(identifier);
  }

  return identifiers;
}

function insertStyleElement(options) {
  var style = document.createElement('style');
  var attributes = options.attributes || {};

  if (typeof attributes.nonce === 'undefined') {
    var nonce =  true ? __webpack_require__.nc : 0;

    if (nonce) {
      attributes.nonce = nonce;
    }
  }

  Object.keys(attributes).forEach(function (key) {
    style.setAttribute(key, attributes[key]);
  });

  if (typeof options.insert === 'function') {
    options.insert(style);
  } else {
    var target = getTarget(options.insert || 'head');

    if (!target) {
      throw new Error("Couldn't find a style target. This probably means that the value for the 'insert' parameter is invalid.");
    }

    target.appendChild(style);
  }

  return style;
}

function removeStyleElement(style) {
  // istanbul ignore if
  if (style.parentNode === null) {
    return false;
  }

  style.parentNode.removeChild(style);
}
/* istanbul ignore next  */


var replaceText = function replaceText() {
  var textStore = [];
  return function replace(index, replacement) {
    textStore[index] = replacement;
    return textStore.filter(Boolean).join('\n');
  };
}();

function applyToSingletonTag(style, index, remove, obj) {
  var css = remove ? '' : obj.media ? "@media ".concat(obj.media, " {").concat(obj.css, "}") : obj.css; // For old IE

  /* istanbul ignore if  */

  if (style.styleSheet) {
    style.styleSheet.cssText = replaceText(index, css);
  } else {
    var cssNode = document.createTextNode(css);
    var childNodes = style.childNodes;

    if (childNodes[index]) {
      style.removeChild(childNodes[index]);
    }

    if (childNodes.length) {
      style.insertBefore(cssNode, childNodes[index]);
    } else {
      style.appendChild(cssNode);
    }
  }
}

function applyToTag(style, options, obj) {
  var css = obj.css;
  var media = obj.media;
  var sourceMap = obj.sourceMap;

  if (media) {
    style.setAttribute('media', media);
  } else {
    style.removeAttribute('media');
  }

  if (sourceMap && typeof btoa !== 'undefined') {
    css += "\n/*# sourceMappingURL=data:application/json;base64,".concat(btoa(unescape(encodeURIComponent(JSON.stringify(sourceMap)))), " */");
  } // For old IE

  /* istanbul ignore if  */


  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    while (style.firstChild) {
      style.removeChild(style.firstChild);
    }

    style.appendChild(document.createTextNode(css));
  }
}

var singleton = null;
var singletonCounter = 0;

function addStyle(obj, options) {
  var style;
  var update;
  var remove;

  if (options.singleton) {
    var styleIndex = singletonCounter++;
    style = singleton || (singleton = insertStyleElement(options));
    update = applyToSingletonTag.bind(null, style, styleIndex, false);
    remove = applyToSingletonTag.bind(null, style, styleIndex, true);
  } else {
    style = insertStyleElement(options);
    update = applyToTag.bind(null, style, options);

    remove = function remove() {
      removeStyleElement(style);
    };
  }

  update(obj);
  return function updateStyle(newObj) {
    if (newObj) {
      if (newObj.css === obj.css && newObj.media === obj.media && newObj.sourceMap === obj.sourceMap) {
        return;
      }

      update(obj = newObj);
    } else {
      remove();
    }
  };
}

module.exports = function (list, options) {
  options = options || {}; // Force single-tag solution on IE6-9, which has a hard limit on the # of <style>
  // tags it will allow on a page

  if (!options.singleton && typeof options.singleton !== 'boolean') {
    options.singleton = isOldIE();
  }

  list = list || [];
  var lastIdentifiers = modulesToDom(list, options);
  return function update(newList) {
    newList = newList || [];

    if (Object.prototype.toString.call(newList) !== '[object Array]') {
      return;
    }

    for (var i = 0; i < lastIdentifiers.length; i++) {
      var identifier = lastIdentifiers[i];
      var index = getIndexByIdentifier(identifier);
      stylesInDom[index].references--;
    }

    var newLastIdentifiers = modulesToDom(newList, options);

    for (var _i = 0; _i < lastIdentifiers.length; _i++) {
      var _identifier = lastIdentifiers[_i];

      var _index = getIndexByIdentifier(_identifier);

      if (stylesInDom[_index].references === 0) {
        stylesInDom[_index].updater();

        stylesInDom.splice(_index, 1);
      }
    }

    lastIdentifiers = newLastIdentifiers;
  };
};

/***/ }),

/***/ 7135:
/***/ (function(module) {

module.exports = __WEBPACK_EXTERNAL_MODULE__7135__;

/***/ }),

/***/ 7997:
/***/ (function(module) {

module.exports = __WEBPACK_EXTERNAL_MODULE__7997__;

/***/ }),

/***/ 1895:
/***/ (function(module) {

module.exports = __WEBPACK_EXTERNAL_MODULE__1895__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			id: moduleId,
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/compat get default export */
/******/ 	!function() {
/******/ 		// getDefaultExport function for compatibility with non-harmony modules
/******/ 		__webpack_require__.n = function(module) {
/******/ 			var getter = module && module.__esModule ?
/******/ 				function() { return module['default']; } :
/******/ 				function() { return module; };
/******/ 			__webpack_require__.d(getter, { a: getter });
/******/ 			return getter;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/define property getters */
/******/ 	!function() {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = function(exports, definition) {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	!function() {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = function(exports) {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/nonce */
/******/ 	!function() {
/******/ 		__webpack_require__.nc = undefined;
/******/ 	}();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
!function() {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  "HawkeyeViewModel": function() { return /* reexport */ HawkeyeViewModel; },
  "default": function() { return /* reexport */ Hawkeye; }
});

// EXTERNAL MODULE: external {"root":"Vue","commonjs":"vue","commonjs2":"vue","amd":"vue"}
var external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_ = __webpack_require__(1895);
// EXTERNAL MODULE: external "@kq_npm/client_common_vue/_utils/gis-utils"
var gis_utils_ = __webpack_require__(7135);
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/HawkeyeViewModel.js
/*
 * Copyright (C) 2019 KQ GEO Technologies Co., Ltd.
 * All rights reserved.
 */
/**
 * Author: ZL
 * Data: 2022.9.21
 * Description: 鹰眼组件逻辑类.
 */



class HawkeyeViewModel extends L.Evented {
  /**
   * @param {Object} props 组件外部传入参数对象
   * @event webMapMounted 获取到地图，并初始化鹰眼后执行的事件
   */
  constructor(props) {
    super();

    /**
     * 绑定地图的target
     * @private
     */
    this._mapTarget = props.mapTarget;

    /**
     * 组件外部传入参数对象
     * @type {Object}
     * @private
     */
    this._props = props;

    this._loaded = this._loaded.bind(this);
  }

  /**
   * 初始化
   */
  init() {
    gis_utils_.utils.getWebMap(this._mapTarget, this._loaded);
  }

  /**
   * 获取地图后的回调函数
   * @param {MapViewViewModel} webmap 地图对象
   * @fires webMapMounted
   * @private
   */
  _loaded(webmap) {
    this._webMap = webmap;

    this.start();

    this.fire("webMapMounted");
  }

  /**
   * 初始化鹰眼
   */
  start() {
    let params = {};
    for (let item in this._props) {
      if (this._props[item] !== null && this._props[item] !== undefined && item !== "layerData") {
        params[item] = this._props[item];
      }
    }

    // 鹰眼的第三方库的position和kq组件的大小写不一样 格式化成一样的
    if (params["position"]) {
      params["position"] = params["position"].toLowerCase();
    }

    this._webMap.mapControl.startMiniMap(this._props.layerData, params);
  }

  /**
   * 给鹰眼注册事件
   * @param {string} type
   * @param {Function} fn
   */
  bindEvents(type, fn) {
    this._webMap.mapControl.miniMap.on(type, fn);
  }

  removeHawkeye() {
    this._webMap.mapControl.removeMinimap();
  }

  /**
   * 销毁
   */
  destroy() {
    this.off();
    this.removeHawkeye();
  }
}

;// CONCATENATED MODULE: ./node_modules/vue-loader/dist/index.js??ruleSet[0].use[0]!./src/leaflet/hawkeye/Hawkeye.vue?vue&type=script&setup=true&lang=js




const __default__ = {
  name: "Kq2dHawkeye"
};

/* harmony default export */ var Hawkeyevue_type_script_setup_true_lang_js = (/*#__PURE__*/Object.assign(__default__, {
  props: {
  mapTarget: String,
  // 图层数据
  layerData: Array,
  // 标准 Leaflet.Control 位置参数，与所有其他控件一样使用。默认为“bottomRight”。
  position: { type: String, default: "bottomRight" },
  // 小地图的宽度，以像素为单位。默认为 150。
  width: { type: Number, default: 150 },
  // 小地图的高度（以像素为单位）。默认为 150。
  height: { type: Number, default: 150 },
  // 折叠时切换标记和小地图的宽度，以像素为单位。默认为 19。
  collapsedWidth: { type: Number, default: 19 },
  // 折叠时切换标记和小地图的高度，以像素为单位。默认为 19。
  collapsedHeight: { type: Number, default: 19 },
  // 与主地图缩放相比，应用于小地图缩放的偏移量。可以是正数或负数，默认为 -5。
  zoomLevelOffset: { type: Number, default: -5 },
  // 覆盖偏移量以将固定缩放级别应用于小地图，而不管主地图缩放。如果改为使用未设置的 zoomLevelOffset，请将其设置为任何有效的缩放级别。
  zoomLevelFixed: { type: Boolean, default: false },
  // 无论主地图的视图/位置如何，都将固定位置应用于小地图。防止平移小地图，但允许缩放（在小地图和主地图中）。如果小地图被缩放，它将始终围绕 centerFixed 点进行缩放。您可以传入一个与 LatLng 等效的对象。默认为false。
  centerFixed: { type: Boolean, default: false },
  // 设置小地图是否应该有动画缩放。 （会导致它在主地图移动后稍微滞后。）默认为 false。
  zoomAnimation: { type: Boolean, default: false },
  // 设置小地图是否应该有一个按钮来最小化它。默认为false。
  toggleDisplay: { type: Boolean, default: false },
  // 设置如果父地图边界不适合小地图边界，小地图是否应自动隐藏。当设置了 'zoomLevelFixed' 时特别有用。
  autoToggleDisplay: { type: Boolean, default: false },
  // 设置小地图是否应该从最小化位置开始。
  minimized: { type: Boolean, default: false },
  // 通过传入一个 Path.Options 对象来设置瞄准矩形的样式。 （Clickable 将始终被覆盖并设置为 false。）
  aimingRectOptions: { type: Object, default: null },
  // 通过传入一个 Path.Options 对象来设置瞄准阴影矩形的样式。 （Clickable 将始终被覆盖并设置为 false。）
  shadowRectOptions: { type: Object, default: null },
  // 覆盖允许翻译的默认字符串。请参阅下面的可用字符串和 example/example_i18n.html 以获取示例{ hideText: '',  showText: ''}
  strings: { type: Object, default: null },
  // 设置 MiniMap 地图的 Leaflet 选项。它不会覆盖 MiniMap 默认地图选项，而是扩展它们
  mapOptions: { type: Object, default: null }
},
  emits: ["toggle", "minimize", "restore"],
  setup(__props, { emit }) {

const props = __props;



(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.watch)(
  () => [
    props.mapTarget,
    props.layerData,
    props.width,
    props.height,
    props.collapsedWidth,
    props.collapsedHeight,
    props.zoomLevelOffset,
    props.zoomLevelFixed,
    props.centerFixed,
    props.zoomAnimation,
    props.toggleDisplay,
    props.autoToggleDisplay,
    props.minimized,
    props.aimingRectOptions,
    props.shadowRectOptions,
    props.strings,
    props.mapOptions
  ],
  (newVal, oldVal) => {
    if (viewModel) {
      viewModel.destroy();

      viewModel.removeHawkeye();
    }

    initViewModel();
  }
);

let viewModel;

(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.onMounted)(() => {
  initViewModel();
});

(0,external_root_Vue_commonjs_vue_commonjs2_vue_amd_vue_.onBeforeUnmount)(() => {
  viewModel.destroy();

  viewModel = null;
});



function initViewModel() {
  viewModel = new HawkeyeViewModel(props);

  viewModel.on("webMapMounted", () => {
    viewModel.bindEvents("toggle", toggle);
    viewModel.bindEvents("minimize", minimize);
    viewModel.bindEvents("restore", restore);
  });

  viewModel.init();
}

/**
 * 切换
 */
function toggle() {
  emit("toggle");
}

/**
 * 做小化
 */
function minimize() {
  emit("minimize");
}

/**
 * 还原
 */
function restore() {
  emit("restore");
}

return (_ctx, _cache) => {
  return null
}
}

}));
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/Hawkeye.vue?vue&type=script&setup=true&lang=js
 
// EXTERNAL MODULE: ./node_modules/style-loader/dist/runtime/injectStylesIntoStyleTag.js
var injectStylesIntoStyleTag = __webpack_require__(3379);
var injectStylesIntoStyleTag_default = /*#__PURE__*/__webpack_require__.n(injectStylesIntoStyleTag);
// EXTERNAL MODULE: ./node_modules/css-loader/dist/cjs.js!./node_modules/vue-loader/dist/stylePostLoader.js!./node_modules/vue-loader/dist/index.js??ruleSet[0].use[0]!./src/leaflet/hawkeye/Hawkeye.vue?vue&type=style&index=0&id=3e34b2f5&lang=css
var Hawkeyevue_type_style_index_0_id_3e34b2f5_lang_css = __webpack_require__(504);
;// CONCATENATED MODULE: ./node_modules/style-loader/dist/cjs.js!./node_modules/css-loader/dist/cjs.js!./node_modules/vue-loader/dist/stylePostLoader.js!./node_modules/vue-loader/dist/index.js??ruleSet[0].use[0]!./src/leaflet/hawkeye/Hawkeye.vue?vue&type=style&index=0&id=3e34b2f5&lang=css

            

var options = {};

options.insert = "head";
options.singleton = false;

var update = injectStylesIntoStyleTag_default()(Hawkeyevue_type_style_index_0_id_3e34b2f5_lang_css/* default */.Z, options);



/* harmony default export */ var hawkeye_Hawkeyevue_type_style_index_0_id_3e34b2f5_lang_css = (Hawkeyevue_type_style_index_0_id_3e34b2f5_lang_css/* default.locals */.Z.locals || {});
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/Hawkeye.vue?vue&type=style&index=0&id=3e34b2f5&lang=css

;// CONCATENATED MODULE: ./src/leaflet/hawkeye/Hawkeye.vue



;

const __exports__ = Hawkeyevue_type_script_setup_true_lang_js;

/* harmony default export */ var Hawkeye = (__exports__);
// EXTERNAL MODULE: external "@kq_npm/client_common_vue/init.js"
var init_js_ = __webpack_require__(7997);
var init_js_default = /*#__PURE__*/__webpack_require__.n(init_js_);
;// CONCATENATED MODULE: ./src/leaflet/hawkeye/index.js
/*
 * Copyright (C) 2019 KQ GEO Technologies Co., Ltd.
 * All rights reserved.
 */




Hawkeye.install = (Vue, opts) => {
  init_js_default()(Vue, opts);
  Vue.component(Hawkeye.name, Hawkeye);
};



}();
/******/ 	return __webpack_exports__;
/******/ })()
;
});